## minio-client 0.0~20241117

=== Makefile ===
PWD := $(shell pwd)
GOPATH := $(shell go env GOPATH)
LDFLAGS := $(shell go run buildscripts/gen-ldflags.go)

GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)

VERSION ?= $(shell git describe --tags)
TAG ?= "minio/mc:$(VERSION)"

GOLANGCI_DIR = .bin/golangci/$(GOLANGCI_VERSION)
GOLANGCI = $(GOLANGCI_DIR)/golangci-lint

all: build

checks:
	@echo "Checking dependencies"
	@(env bash $(PWD)/buildscripts/checkdeps.sh)

getdeps:
	@mkdir -p ${GOPATH}/bin
	@echo "Installing golangci-lint" && curl -sSfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh | sh -s -- -b $(GOLANGCI_DIR)
	@echo "Installing stringer" && go install -v golang.org/x/tools/cmd/stringer@latest

crosscompile:
	@(env bash $(PWD)/buildscripts/cross-compile.sh)

verifiers: getdeps vet lint

docker: build
	@docker build -t $(TAG) . -f Dockerfile.dev

vet:
	@echo "Running $@"
	@GO111MODULE=on go vet github.com/minio/mc/...

lint-fix: getdeps ## runs golangci-lint suite of linters with automatic fixes
	@echo "Running $@ check"
	@$(GOLANGCI) run --build-tags kqueue --timeout=10m --config ./.golangci.yml --fix

lint: getdeps
	@echo "Running $@ check"
	@$(GOLANGCI) run --build-tags kqueue --timeout=10m --config ./.golangci.yml

# Builds mc, runs the verifiers then runs the tests.
check: test
test: verifiers build
	@echo "Running unit tests"
	@GO111MODULE=on CGO_ENABLED=0 go test -tags kqueue ./... 1>/dev/null
	@echo "Running functional tests"
	@GO111MODULE=on MC_TEST_RUN_FULL_SUITE=true go test -race -v --timeout 20m ./... -run Test_FullSuite

test-race: verifiers build
	@echo "Running unit tests under -race"
	@GO111MODULE=on go test -race -v --timeout 20m ./... 1>/dev/null

# Verify mc binary
verify:
	@echo "Verifying build with race"
	@GO111MODULE=on CGO_ENABLED=1 go build -race -tags kqueue -trimpath --ldflags "$(LDFLAGS)" -o $(PWD)/mc 1>/dev/null
	@echo "Running functional tests"
	@GO111MODULE=on MC_TEST_RUN_FULL_SUITE=true go test -race -v --timeout 20m ./... -run Test_FullSuite

# Builds mc locally.
build: checks
	@echo "Building mc binary to './mc'"
	@GO111MODULE=on CGO_ENABLED=0 go build -trimpath -tags kqueue --ldflags "$(LDFLAGS)" -o $(PWD)/mc

hotfix-vars:
	$(eval LDFLAGS := $(shell MC_RELEASE="RELEASE" MC_HOTFIX="hotfix.$(shell git rev-parse --short HEAD)" go run buildscripts/gen-ldflags.go $(shell git describe --tags --abbrev=0 | \
    sed 's#RELEASE\.\([0-9]\+\)-\([0-9]\+\)-\([0-9]\+\)T\([0-9]\+\)-\([0-9]\+\)-\([0-9]\+\)Z#\1-\2-\3T\4:\5:\6Z#')))
	$(eval VERSION := $(shell git describe --tags --abbrev=0).hotfix.$(shell git rev-parse --short HEAD))
	$(eval TAG := "minio/mc:$(VERSION)")

hotfix: hotfix-vars install ## builds mc binary with hotfix tags
	@mv -f ./mc ./mc.$(VERSION)
	@minisign -qQSm ./mc.$(VERSION) -s "${CRED_DIR}/minisign.key" < "${CRED_DIR}/minisign-passphrase"
	@sha256sum < ./mc.$(VERSION) | sed 's, -,mc.$(VERSION),g' > mc.$(VERSION).sha256sum

hotfix-push: hotfix
	@scp -q -r mc.$(VERSION)* minio@dl-0.min.io:~/releases/client/mc/hotfixes/linux-amd64/archive/
	@scp -q -r mc.$(VERSION)* minio@dl-1.min.io:~/releases/client/mc/hotfixes/linux-amd64/archive/
	@echo "Published new hotfix binaries at https://dl.min.io/client/mc/hotfixes/linux-amd64/archive/mc.$(VERSION)"

docker-hotfix-push: docker-hotfix
	@docker push -q $(TAG) && echo "Published new container $(TAG)"

docker-hotfix: hotfix-push checks ## builds mc docker container with hotfix tags
	@echo "Building mc docker image '$(TAG)'"
	@docker build -q --no-cache -t $(TAG) --build-arg RELEASE=$(VERSION) . -f Dockerfile.hotfix

# Builds MinIO and installs it to $GOPATH/bin.
install: build
	@echo "Installing mc binary to '$(GOPATH)/bin/mc'"
	@mkdir -p $(GOPATH)/bin && cp -f $(PWD)/mc $(GOPATH)/bin/mc
	@echo "Installation successful. To learn more, try \"mc --help\"."

clean:
	@echo "Cleaning up all the generated files"
	@find . -name '*.test' | xargs rm -fv
	@find . -name '*~' | xargs rm -fv
	@rm -rvf mc
	@rm -rvf build
	@rm -rvf release

=== debian/changelog ===
minio-client (0.0~20241117-1) unstable; urgency=medium

  * Initial release (Closes: #1076583)

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 18 Dec 2024 00:54:19 +0000

## minio-client 0.0~20241121

=== debian/changelog ===
minio-client (0.0~20241121-1) unstable; urgency=medium

  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Wed, 08 Jan 2025 14:23:00 +0000

## minio-client 0.0~20250117

=== debian/changelog ===
minio-client (0.0~20250117-1) unstable; urgency=medium

  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 26 Jan 2025 01:38:08 +0000

=== debian/control ===
Source: minio-client
Section: golang
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Mathias Gibbens <gibmat@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
               dh-sequence-golang,
               golang-any,
               golang-github-charmbracelet-bubbles-dev,
               golang-github-charmbracelet-bubbletea-dev,
               golang-github-charmbracelet-lipgloss-dev,
               golang-github-dustin-go-humanize-dev,
               golang-github-fatih-color-dev,
               golang-github-golang-jwt-jwt-dev,
               golang-github-google-shlex-dev,
               golang-github-google-uuid-dev,
               golang-github-inconshreveable-mousetrap-dev,
               golang-github-jedib0t-go-pretty-dev,
               golang-github-juju-ratelimit-dev,
               golang-github-klauspost-compress-dev,
               golang-github-mattn-go-ieproxy-dev,
               golang-github-mattn-go-isatty-dev,
               golang-github-minio-cli-dev,
               golang-github-minio-colorjson-dev,
               golang-github-minio-filepath-dev,
               golang-github-minio-madmin-go-dev,
               golang-github-minio-minio-go-dev,
               golang-github-minio-pkg-dev,
               golang-github-minio-selfupdate-dev,
               golang-github-mitchellh-go-homedir-dev,
               golang-github-muesli-reflow-dev,
               golang-github-muesli-termenv-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-pkg-xattr-dev,
               golang-github-posener-complete-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-rjeczalik-notify-dev,
               golang-github-rs-xid-dev,
               golang-github-shirou-gopsutil-dev,
               golang-github-tidwall-gjson-dev,
               golang-github-vbauerster-mpb-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-term-dev,
               golang-golang-x-text-dev,
               golang-gopkg-check.v1-dev,
               golang-gopkg-cheggaaa-pb.v1-dev,
               golang-gopkg-yaml.v2-dev,
               golang-procfs-dev,
               help2man
Testsuite: autopkgtest-pkg-go
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/minio-client
Vcs-Git: https://salsa.debian.org/go-team/packages/minio-client.git
Homepage: https://github.com/minio/mc
XS-Go-Import-Path: github.com/minio/mc

Package: minio-client
Section: admin
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Simple, fast tool to manage MinIO clusters
 MinIO Client (mc) provides a modern alternative to UNIX commands like
 ls, cat, cp, mirror, diff, find etc. It supports filesystems and Amazon
 S3 compatible cloud storage service (AWS Signature v2 and v4).
 .
 In Debian, the binary is installed as `/usr/bin/minio-client`; for further
 details, please refer to the README.Debian file for this package.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --builddirectory=_build --buildsystem=golang

execute_after_dh_auto_build:
	# Rename binary to deconflict with Midnight Commander (see https://lists.debian.org/debian-devel/2024/04/msg00368.html)
	mv _build/bin/mc _build/bin/minio-client

	# Generate the man pages
	mkdir man1/
	TZ=UTC HOME="~" help2man _build/bin/minio-client -n "Unix like utilities for object store" --no-info --no-discard-stderr --version-string=$(DEB_VERSION_UPSTREAM) > man1/minio-client.1

override_dh_auto_install:
	dh_auto_install -- --no-source

=== debian/watch ===
# Upstream has release tags like "RELEASE.2024-11-17T19-35-25Z", which don't parse into a nice
# package version. Extract the date components and strip out the hyphens to produce a nicer version.
# The version mangle also prefixes a "0.0~" just in case upstream decides to switch from timestamps
# to a semantic versioning approach down the road so we wouldn't need an epoch bump to deal with
# such a change.

version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
      uversionmangle=s/(\d{4})-(\d{2})-(\d{2})/0.0~$1$2$3/" \
  https://github.com/minio/mc/tags .*/RELEASE\.(\d{4}-\d{2}-\d{2})T\d{2}-\d{2}-\d{2}Z\.tar\.gz debian

## minio-client 0.0~20250312

=== debian/changelog ===
minio-client (0.0~20250312-1) unstable; urgency=medium

  * New upstream release
    - Rebase patch
  * Update Standards-Version to 4.7.2 in d/control (no changes needed)

 -- Mathias Gibbens <gibmat@debian.org>  Thu, 20 Mar 2025 13:23:37 +0000

=== debian/control ===
--- 
+++ 
@@ -50,7 +50,7 @@
                golang-procfs-dev,
                help2man
 Testsuite: autopkgtest-pkg-go
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/go-team/packages/minio-client
 Vcs-Git: https://salsa.debian.org/go-team/packages/minio-client.git
 Homepage: https://github.com/minio/mc

## minio-client 0.0~20250403

=== Makefile ===
--- 
+++ 
@@ -2,8 +2,8 @@
 GOPATH := $(shell go env GOPATH)
 LDFLAGS := $(shell go run buildscripts/gen-ldflags.go)
 
-GOARCH := $(shell go env GOARCH)
-GOOS := $(shell go env GOOS)
+TARGET_GOARCH ?= $(shell go env GOARCH)
+TARGET_GOOS ?= $(shell go env GOOS)
 
 VERSION ?= $(shell git describe --tags)
 TAG ?= "minio/mc:$(VERSION)"
@@ -64,7 +64,7 @@
 # Builds mc locally.
 build: checks
 	@echo "Building mc binary to './mc'"
-	@GO111MODULE=on CGO_ENABLED=0 go build -trimpath -tags kqueue --ldflags "$(LDFLAGS)" -o $(PWD)/mc
+	@GO111MODULE=on GOOS=$(TARGET_GOOS) GOARCH=$(TARGET_GOARCH) CGO_ENABLED=0 go build -trimpath -tags kqueue --ldflags "$(LDFLAGS)" -o $(PWD)/mc
 
 hotfix-vars:
 	$(eval LDFLAGS := $(shell MC_RELEASE="RELEASE" MC_HOTFIX="hotfix.$(shell git rev-parse --short HEAD)" go run buildscripts/gen-ldflags.go $(shell git describe --tags --abbrev=0 | \
@@ -78,9 +78,9 @@
 	@sha256sum < ./mc.$(VERSION) | sed 's, -,mc.$(VERSION),g' > mc.$(VERSION).sha256sum
 
 hotfix-push: hotfix
-	@scp -q -r mc.$(VERSION)* minio@dl-0.min.io:~/releases/client/mc/hotfixes/linux-amd64/archive/
-	@scp -q -r mc.$(VERSION)* minio@dl-1.min.io:~/releases/client/mc/hotfixes/linux-amd64/archive/
-	@echo "Published new hotfix binaries at https://dl.min.io/client/mc/hotfixes/linux-amd64/archive/mc.$(VERSION)"
+	@scp -q -r mc.$(VERSION)* minio@dl-0.min.io:~/releases/client/mc/hotfixes/$(TARGET_GOOS)-$(TARGET_GOARCH)/archive/
+	@scp -q -r mc.$(VERSION)* minio@dl-1.min.io:~/releases/client/mc/hotfixes/$(TARGET_GOOS)-$(TARGET_GOARCH)/archive/
+	@echo "Published new hotfix binaries at https://dl.min.io/client/mc/hotfixes/$(TARGET_GOOS)-$(TARGET_GOARCH)/archive/mc.$(VERSION)"
 
 docker-hotfix-push: docker-hotfix
 	@docker push -q $(TAG) && echo "Published new container $(TAG)"

=== debian/changelog ===
minio-client (0.0~20250403-4) unstable; urgency=medium

  * Add patch with fixes for tablewriter API changes
  * Update required tablewriter version in Build-Depends

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 22 Aug 2025 01:21:52 +0000

minio-client (0.0~20250403-3) unstable; urgency=medium

  * Add back Built-Using stanza in d/control

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 27 Apr 2025 15:07:02 +0000

minio-client (0.0~20250403-2) unstable; urgency=medium

  * Set minimum required version of golang-github-minio-madmin-go

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 07 Apr 2025 18:42:07 +0000

minio-client (0.0~20250403-1) unstable; urgency=medium

  * New upstream release

 -- Mathias Gibbens <gibmat@debian.org>  Sun, 06 Apr 2025 13:57:21 +0000

minio-client (0.0~20250312-2) unstable; urgency=medium

  * d/control:
    - Update Build-Depends on golang-github-minio-minio-go-dev ->
      golang-github-minio-minio-go-v7-dev
    - Replace Built-Using with Static-Built-Using

 -- Mathias Gibbens <gibmat@debian.org>  Mon, 31 Mar 2025 23:06:59 +0000

=== debian/control ===
--- 
+++ 
@@ -24,14 +24,14 @@
                golang-github-minio-cli-dev,
                golang-github-minio-colorjson-dev,
                golang-github-minio-filepath-dev,
-               golang-github-minio-madmin-go-dev,
-               golang-github-minio-minio-go-dev,
+               golang-github-minio-madmin-go-dev (>= 3.0.104),
+               golang-github-minio-minio-go-v7-dev,
                golang-github-minio-pkg-dev,
                golang-github-minio-selfupdate-dev,
                golang-github-mitchellh-go-homedir-dev,
                golang-github-muesli-reflow-dev,
                golang-github-muesli-termenv-dev,
-               golang-github-olekukonko-tablewriter-dev,
+               golang-github-olekukonko-tablewriter-dev (>= 1.0.9),
                golang-github-pkg-xattr-dev,
                golang-github-posener-complete-dev,
                golang-github-prometheus-client-golang-dev,
@@ -62,6 +62,7 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Description: Simple, fast tool to manage MinIO clusters
  MinIO Client (mc) provides a modern alternative to UNIX commands like
  ls, cat, cp, mirror, diff, find etc. It supports filesystems and Amazon

## minio-client 0.0~20250813

=== debian/changelog ===
minio-client (0.0~20250813-1) unstable; urgency=medium

  * New upstream release
    - Rebase patch for tablewriter API changes
  * d/control:
    - Update Build-Depends
    - Drop redundant Rules-Requires-Root

 -- Mathias Gibbens <gibmat@debian.org>  Tue, 18 Nov 2025 14:33:35 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Mathias Gibbens <gibmat@debian.org>
-Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-golang,
                golang-any,
@@ -24,7 +23,7 @@
                golang-github-minio-cli-dev,
                golang-github-minio-colorjson-dev,
                golang-github-minio-filepath-dev,
-               golang-github-minio-madmin-go-dev (>= 3.0.104),
+               golang-github-minio-madmin-go-dev (>= 3.0.107),
                golang-github-minio-minio-go-v7-dev,
                golang-github-minio-pkg-dev,
                golang-github-minio-selfupdate-dev,
